@echo off
echo Borrando ficheros temporales
del *.asm
del *.ihx
del *.lst
del *.sym
echo Borrando rom
del *.sms
echo Reexportar graficos
.\bmp2tile\bmp2tile.exe .\gfx\logo.png -mirror -removedupes -savetiles .\assets\logotiles.psgcompr -savepalette .\assets\logopalette.bin -savetilemap .\assets\logotilemap.stmcompr -exit
.\bmp2tile\bmp2tile.exe .\gfx\pieces.png -noremovedupes -savetiles .\assets\piecestiles.psgcompr -savepalette .\assets\piecespalette.bin -exit
.\bmp2tile\bmp2tile.exe .\gfx\background.png -mirror -removedupes -savetiles .\assets\backgroundtiles.psgcompr -savepalette .\assets\backgroundpalette.bin -tileoffset 21 -savetilemap .\assets\backgroundtilemap.stmcompr -exit
.\bmp2tile\bmp2tile.exe .\gfx\simplefont.png -savetiles .\assets\simplefont.psgcompr -exit
.\bmp2tile\bmp2tile.exe .\gfx\titlescreen.png -mirror -removedupes -savetiles .\assets\titlescreentiles.psgcompr -savepalette .\assets\titlescreenpalette.bin -savetilemap .\assets\titlescreentilemap.stmcompr -exit
echo Convertir ficheros de graficos a C y compilarlos
assets2banks assets --compile
if %errorlevel% neq 0 exit
echo Compilar Librerias
sdcc -c -mz80 --peep-file peep-rules.txt libs/montylib.c
if %errorlevel% neq 0 exit
echo Compilar Engine
sdcc -c -mz80 --peep-file peep-rules.txt engine/gamelogic.c
if %errorlevel% neq 0 exit
sdcc -c -mz80 --peep-file peep-rules.txt engine/resources.c
if %errorlevel% neq 0 exit
sdcc -c -mz80 --peep-file peep-rules.txt engine/board.c
if %errorlevel% neq 0 exit
echo Compilar Juego
sdcc -c -mz80 --peep-file peep-rules.txt game.c
if %errorlevel% neq 0 exit
echo Linkar Juego
sdcc -o gotris.ihx -mz80 --no-std-crt0 --data-loc 0xC000 -Wl-b_BANK2=0x8000 -Wl-b_BANK3=0x8000 crt0_sms.rel game.rel montylib.rel gamelogic.rel resources.rel board.rel bank2.rel bank3.rel SMSlib.lib libs/PSGLib.rel
if %errorlevel% neq 0 exit
echo Convertir de binario a rom
ihx2sms gotris.ihx gotris.sms
if %errorlevel% neq 0 exit
echo Ejecutar emulador
java -jar c:\Users\JordiM\Desktop\emuladores\mastersystem\Emulicious\Emulicious.jar gotris.sms